//vecview.cc -*-c++-*-
#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/vector_expression.hpp>
#include <boost/numeric/ublas/io.hpp>

#include<algorithm>
#include<iterator>

using namespace boost::numeric::ublas;

typedef double realsc;

//
// "vecview_col" is a proxy class which tries to represent a matrix as vector
// of columns,with all consequences. "value_type" is a column of matrix.
// "vecview_col" is not fully implemented. I have written only the relevant
// parts to show where compilation fails.
//
// Here MT is some type of matrix with from boost ublas.
//
template<typename MT> class vecview_col
  : public vector_expression<vecview_col<MT> > {
 private:
  MT & mr;
  typedef matrix_column<MT> mc_t;
  typedef vector_expression<vecview_col<MT> > base_t;

 public:
  typedef mc_t value_type;
  vecview_col(MT & _mr) :mr(_mr) {}

  //
  //Here only declarations of methods.Just to show where compilation fails.
  //
  vecview_col & assign(base_t const & vc);
  vecview_col & operator=(base_t const & vc);
  vecview_col & assign(vector<value_type> const & vc);
  vecview_col & operator=(vector<value_type> const & vc);
};

// Template specialization should be in the same namespace,
// so I have to intervene into boost::numeric::ublas namespace
namespace boost{ namespace numeric{ namespace ublas {
  template<typename MT> struct promote_traits<realsc,matrix_column<MT> > {
    typedef matrix_column<MT> promote_type;
  };
 }}
}

typedef vecview_col<matrix<realsc> > vcv_t;
typedef matrix<realsc> mr_t;

int main () {

  mr_t m1(2,2),m2(2,2),
    m3(2,2),m33(2,2),m33_2(2,2);
  // If this will ever compile and run,
  // at the end of program m3,m33,m33_2 should have same contents.

  m1(0,0) = 1.12;   m1(0,1) = 23.5;
  m1(1,0) = -150.1; m1(1,1) = -9.8;

  m2(0,0) = -13.7;   m2(0,1) = 3.4;
  m2(1,0) = 100.9;   m2(1,1) = 87.5;

  m3 = prod(m2,trans(m1)); //"on columns" transformation of "m2" using "m1"

  //Here the problematic part. Trying to do the "same" other way:
  {
    vcv_t v(m33),vv(m33_2);
    v = prod(m1,vcv_t(m2));
    noalias(vv)=prod(m1,vcv_t(m2));
  }

  std::cout << m3 << std::endl;
  //  std::cout << prod(m1,vcv_t(m2)) << std::endl;
  std::cout << m33 << std::endl;

  return 0;
}

